## libmceliece 0~20250507

=== Makefile ===
default:
	cd build && $(MAKE)

install:
	cd build && $(MAKE) install

clean:
	cd build && $(MAKE) clean

=== crypto_xof/shake256/unrollround/Makefile ===
keccak.inc: keccak.py
	./keccak.py > keccak.inc

## libmceliece 0~20230612

=== debian/changelog ===
libmceliece (0~20230612-3) unstable; urgency=medium

  * d/changelog: fix typo
    libmceliece1.symbols.x32.amd64 -> libmceliece1.symbols.amd64
  * d/control: remove 'Multi-Arch: same' for the package libmceliece-dev,
    libmceliece-dev contains the mceliece.h header file, which is different
    across platforms.
  * d/gbp.conf: add [pull] track-missing = True
  * d/copyright: bump copyright year

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Fri, 05 Jan 2024 17:50:35 +0100

libmceliece (0~20230612-2) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/t/testmceliece-{static,shared} speedup tests, run only one tests for
    the variant 6960119
  * d/t/control run  autopkgtests mceliece-test for all variants
    {6960119, 6688128, 8192128, 460896, 348864}
  * d/compiler/gcc: Echo commands for blhc.
  * d/rules: detect the correct ABINAME from the DEB_BUILD_ARCH
    instead of run-time detection. Fixes FTBR on i386/armhf/...
  * d/libmceliece1.symbols.x32 add, symbolic link to
    libmceliece1.symbols.amd64
  * d/libmceliece1.symbols add
  * d/rules add DEB_BUILD_MAINT_OPTIONS = optimize=+lto
  * d/watch: use special strings @PACKAGE@, @ANY_VERSION@, @ARCHIVE_EXT@
  * d/p/0001-add-tryifunc.patch: add ifunc detection and fallback to
    constructor where ifunc not available
  * d/control: add Multi-Arch: same
  * d/p/0002-reproducible-ofiles.patch: sort the output of os.listdir()

 -- Simon Josefsson <simon@josefsson.org>  Fri, 29 Dec 2023 17:42:50 +0100

libmceliece (0~20230612-1) unstable; urgency=medium

  * Initial release. (Closes: #1050531)

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 11 Sep 2023 17:32:11 +0200

=== debian/control ===
Source: libmceliece
Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Priority: optional
Standards-Version: 4.6.2
Section: libs
Homepage: https://lib.mceliece.org
Build-Depends:
 debhelper-compat (= 13),
 libcpucycles-dev,
 librandombytes-dev,
 python3,
Vcs-Git: https://salsa.debian.org/debian/libmceliece.git
Vcs-Browser: https://salsa.debian.org/debian/libmceliece
Rules-Requires-Root: no

Package: libmceliece-dev
Section: libdevel
Architecture: any
Depends:
 libmceliece1 (= ${binary:Version}),
 ${misc:Depends},
Description: Classic McEliece microlibrary - development files
 libmceliece is a Classic McEliece microlibrary.
 libmceliece has a very simple stateless API based on the SUPERCOP API,
 with wire-format inputs and outputs, providing functions that directly match
 the KEM operations provided by Classic McEliece, such as functions
 .
 mceliece6960119_keypair
 mceliece6960119_enc
 mceliece6960119_dec
 for the mceliece6960119 KEM.
 .
 Internally, libmceliece is based on the official Classic McEliece software,
 specifically the vec implementation (designed to work portably across CPUs) and
 he avx implementation (designed for higher performance on Intel/AMD CPUs with
 AVX2 instructions). libmceliece includes automatic run-time selection
 of implementations.
 .
 libmceliece is intended to be called by larger multi-function libraries
 (such as traditional cryptographic libraries), including libraries in other
 languages via FFI. The idea is that libmceliece takes responsibility for
 the details of Classic McEliece computation, including optimization,
 timing-attack protection, and (in ongoing work) verification,
 freeing up the calling libraries to concentrate on application-specific
 needs such as protocol integration. Applications can also call libmceliece
 directly.
 .
 Development files.

Package: libmceliece1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Classic McEliece microlibrary - shared library
 libmceliece is a Classic McEliece microlibrary.
 libmceliece has a very simple stateless API based on the SUPERCOP API,
 with wire-format inputs and outputs, providing functions that directly match
 the KEM operations provided by Classic McEliece, such as functions
 .
 mceliece6960119_keypair
 mceliece6960119_enc
 mceliece6960119_dec
 for the mceliece6960119 KEM.
 .
 Internally, libmceliece is based on the official Classic McEliece software,
 specifically the vec implementation (designed to work portably across CPUs) and
 he avx implementation (designed for higher performance on Intel/AMD CPUs with
 AVX2 instructions). libmceliece includes automatic run-time selection
 of implementations.
 .
 libmceliece is intended to be called by larger multi-function libraries
 (such as traditional cryptographic libraries), including libraries in other
 languages via FFI. The idea is that libmceliece takes responsibility for
 the details of Classic McEliece computation, including optimization,
 timing-attack protection, and (in ongoing work) verification,
 freeing up the calling libraries to concentrate on application-specific
 needs such as protocol integration. Applications can also call libmceliece
 directly.
 .
 Shared library.

Package: mceliece
Section: devel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Classic McEliece microlibrary - command line tools
 libmceliece is a Classic McEliece microlibrary.
 libmceliece has a very simple stateless API based on the SUPERCOP API,
 with wire-format inputs and outputs, providing functions that directly match
 the KEM operations provided by Classic McEliece, such as functions
 .
 mceliece6960119_keypair
 mceliece6960119_enc
 mceliece6960119_dec
 for the mceliece6960119 KEM.
 .
 Internally, libmceliece is based on the official Classic McEliece software,
 specifically the vec implementation (designed to work portably across CPUs) and
 he avx implementation (designed for higher performance on Intel/AMD CPUs with
 AVX2 instructions). libmceliece includes automatic run-time selection
 of implementations.
 .
 libmceliece is intended to be called by larger multi-function libraries
 (such as traditional cryptographic libraries), including libraries in other
 languages via FFI. The idea is that libmceliece takes responsibility for
 the details of Classic McEliece computation, including optimization,
 timing-attack protection, and (in ongoing work) verification,
 freeing up the calling libraries to concentrate on application-specific
 needs such as protocol integration. Applications can also call libmceliece
 directly.
 .
 Command line tools.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack

# crossbuild
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
include /usr/share/dpkg/buildtools.mk
endif

%:
	dh $@

# In the debian/compiler directory contains gcc and clang wrappers.
# It adds Debian specifific options distributed in
# $CC, $CFLAGS, $CPPFLAGS and $LDFLAGS
export PATH := $(shell pwd)/debian/compiler:$(PATH)

# Detects the correct ABINAME from the DEB_BUILD_ARCH
# instead of run-time detection. Fixes FTBR.
ABINAME=$(DEB_BUILD_ARCH)
ifeq ($(ABINAME), x32)
ABINAME=amd64
endif

override_dh_auto_configure:
	# disable duplicit portable implementation (reproducible build)
	chmod +t crypto_xof/shake256/tweet
	# run configure
	./configure --host=$(ABINAME) --prefix=/usr

override_dh_auto_clean:
	rm -rf ./build

# disable auto installation
override_dh_auto_install:

=== debian/tests/control ===
Tests: testmceliece-static
Depends:
 build-essential,
 dpkg-dev,
 libmceliece-dev,
 librandombytes-dev,

Tests: testmceliece-shared
Depends:
 build-essential,
 dpkg-dev,
 libmceliece-dev,
 libmceliece1,
 librandombytes-dev,

Tests: mceliece
Depends:
 mceliece,

Test-Command: mceliece-test kem 6960119
Depends:
 mceliece,

Test-Command: mceliece-test kem 6688128
Depends:
 mceliece,

Test-Command: mceliece-test kem 8192128
Depends:
 mceliece,

Test-Command: mceliece-test kem 460896
Depends:
 mceliece,

Test-Command: mceliece-test kem 348864
Depends:
 mceliece,

## libmceliece 0~20240513

=== debian/changelog ===
libmceliece (0~20240513-1) unstable; urgency=medium

  * New upstream version 20240513
  * d/p/001-add-tryifunc.patch remove, fixed in upstream
  * d/p/0002-reproducible-ofiles.patch remove, fixed in upstream
  * d/libmceliece1.symbols update
  * d/libmceliece1.symbols.{amd64,x32} remove
  * d/t/testmceliece-{shared,static} fix mceliece-test compilation
  * d/t/testmceliece-{shared,static} speedup tests, test f variants
  * d/rules: fix comments
  * d/rules: don't disable any implementation (re-enable
    crypto_xof/shake256/tweet)
  * d/salsa-ci.yml add
  * d/copyright: bump copyright year
  * d/control: bump Standards-Version: 4.7.0, no changes
  * d/rules: remove optimize=+lto, rollback to default

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Fri, 17 May 2024 18:58:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders:
  Simon Josefsson <simon@josefsson.org>,
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://lib.mceliece.org
 Build-Depends:

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack
 
 # crossbuild
@@ -13,7 +13,7 @@
 %:
 	dh $@
 
-# In the debian/compiler directory contains gcc and clang wrappers.
+# The debian/compiler directory contains gcc and clang wrappers.
 # It adds Debian specifific options distributed in
 # $CC, $CFLAGS, $CPPFLAGS and $LDFLAGS
 export PATH := $(shell pwd)/debian/compiler:$(PATH)
@@ -26,8 +26,6 @@
 endif
 
 override_dh_auto_configure:
-	# disable duplicit portable implementation (reproducible build)
-	chmod +t crypto_xof/shake256/tweet
 	# run configure
 	./configure --host=$(ABINAME) --prefix=/usr

=== debian/tests/control ===
Tests: testmceliece-static
Depends:
 build-essential,
 dpkg-dev,
 libmceliece-dev,
 librandombytes-dev,

Tests: testmceliece-shared
Depends:
 build-essential,
 dpkg-dev,
 libmceliece-dev,
 libmceliece1,
 librandombytes-dev,

Tests: mceliece
Depends:
 mceliece,

Test-Command: mceliece-test kem 6960119f
Depends:
 mceliece,

Test-Command: mceliece-test kem 6688128f
Depends:
 mceliece,

Test-Command: mceliece-test kem 8192128f
Depends:
 mceliece,

Test-Command: mceliece-test kem 460896f
Depends:
 mceliece,

Test-Command: mceliece-test kem 348864f
Depends:
 mceliece,

## libmceliece 0~20241009

=== debian/changelog ===
libmceliece (0~20241009-2) unstable; urgency=medium

  * d/control: use valgrind-if-available instead of valgrind in Recommends
  * d/copyright: bump debian/* copyright year
  * d/salsa-ci.yml: SALSA_CI_ENABLE_WRAP_AND_SORT=1
  * d/control: update my email to "janmojzis@debian.org"

 -- Jan Mojžíš <janmojzis@debian.org>  Sat, 25 Jan 2025 17:01:05 +0100

libmceliece (0~20241009-1) unstable; urgency=medium

  * New upstream version 20241009
  * d/t/testmceliece-static: use dpkg-buildflags to get CFLAGS,LDFLAGS
  * d/t/testmceliece-shared: use dpkg-buildflags to get CFLAGS,LDFLAGS
  * d/gbp.conf: dist = DEP14, debian-branch = debian/latest
  * d/p/0001-workaround-for-timing-problems-on-i386.patch and
    0002-workaround-for-portable-crypto_uint64_bottombit_mask.patch remove,
    fixed in upstream

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Thu, 10 Oct 2024 16:10:54 +0200

libmceliece (0~20240812-3) unstable; urgency=medium

  * d/rules: fix valgrind test ppc64el via hardening=-stackclash
  * d/p/0002-workaround-for-portable-crypto_uint64_bottombit_mask.patch add,
    it's workaround for problems with variable-time code caught by valgrind
    test on armhf
  * d/t/mceliece update, add more debug messages when test fails
  * d/rules remove DEB_CFLAGS_MAINT_APPEND = -funroll-all-loops

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 28 Aug 2024 21:29:36 +0200

libmceliece (0~20240812-2) unstable; urgency=medium

  * d/t/testvalgrind: skip test when valgrind is not available
  * d/rules: fix valgrind test on armhf via hardening=-stackclash
  * d/p/0001-workaround-for-timing-problems-on-i386.patch add, it's workaround
    for problems with variable-time code caught by valgrind test on i386
  * d/rules add DEB_CFLAGS_MAINT_APPEND = -funroll-all-loops

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sat, 24 Aug 2024 20:27:09 +0200

libmceliece (0~20240812-1) unstable; urgency=medium

  * New upstream version 20240812
  * d/t/testvalgrind: update test and remove libmceliece1-dbgsym test
    dependency.
  * d/README.source add
  * d/t/testmceliece-{shared,static} speedup test

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 19 Aug 2024 14:57:26 +0200

libmceliece (0~20240726-3) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/t/testvalgrind add, it is a light version of the test that detects timing
    problems
  * d/t/control: run mceliece-fulltest only on amd64
  * d/t/mceliece: run tests also for 'f' variants
  * d/t/salsa-ci.yml: skip mceliece-speed
  * d/t/salsa-ci.yml: build dbgsym packages

  [ Simon Josefsson ]
  * salsa-ci.yml: Skip mceliece-fulltest.

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sat, 03 Aug 2024 08:46:00 +0200

libmceliece (0~20240726-2) unstable; urgency=medium

  * Use --no-valgrind on archs that valgrind-if-available didn't provide
    valgrind.
  * tests: Fix python Depends for mceliece-fulltest.
  * mceliece: Doc fix of Description:.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 27 Jul 2024 12:52:40 +0200

libmceliece (0~20240726-1) unstable; urgency=medium

  * New upstream version 0~20240726
  * Build-Depend on valgrind-if-available, for valgrind/memcheck.h.
  * tests: Invoke mceliece-fulltest.
  * Add DEP12 metadata.
  * Build-Depend on dh-python for mceliece-fulltest.
  * Add Recommends:python3,valgrind to mceliece and doc fix.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 26 Jul 2024 18:15:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: libmceliece
-Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
+Maintainer: Jan Mojžíš <janmojzis@debian.org>
 Uploaders:
  Simon Josefsson <simon@josefsson.org>,
 Priority: optional
@@ -8,9 +8,11 @@
 Homepage: https://lib.mceliece.org
 Build-Depends:
  debhelper-compat (= 13),
+ dh-python,
  libcpucycles-dev,
  librandombytes-dev,
  python3,
+ valgrind-if-available,
 Vcs-Git: https://salsa.debian.org/debian/libmceliece.git
 Vcs-Browser: https://salsa.debian.org/debian/libmceliece
 Rules-Requires-Root: no
@@ -89,30 +91,67 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Recommends:
+ valgrind-if-available,
+ ${python3:Depends},
 Description: Classic McEliece microlibrary - command line tools
- libmceliece is a Classic McEliece microlibrary.
- libmceliece has a very simple stateless API based on the SUPERCOP API,
- with wire-format inputs and outputs, providing functions that directly match
- the KEM operations provided by Classic McEliece, such as functions
+ libmceliece is an implementation of the Classic McEliece
+ cryptosystem. The command-line interface for libmceliece provides the
+ following command-line tools:
  .
- mceliece6960119_keypair
- mceliece6960119_enc
- mceliece6960119_dec
- for the mceliece6960119 KEM.
+ mceliece348864-dec
+ mceliece348864-enc
+ mceliece348864f-keypair
+ mceliece348864-keypair
+ mceliece348864pc-dec
+ mceliece348864pc-enc
+ mceliece348864pcf-keypair
+ mceliece348864pc-keypair
+ mceliece460896-dec
+ mceliece460896-enc
+ mceliece460896f-keypair
+ mceliece460896-keypair
+ mceliece460896pc-dec
+ mceliece460896pc-enc
+ mceliece460896pcf-keypair
+ mceliece460896pc-keypair
+ mceliece6688128-dec
+ mceliece6688128-enc
+ mceliece6688128f-keypair
+ mceliece6688128-keypair
+ mceliece6688128pc-dec
+ mceliece6688128pc-enc
+ mceliece6688128pcf-keypair
+ mceliece6688128pc-keypair
+ mceliece6960119-dec
+ mceliece6960119-enc
+ mceliece6960119f-keypair
+ mceliece6960119-keypair
+ mceliece6960119pc-dec
+ mceliece6960119pc-enc
+ mceliece6960119pcf-keypair
+ mceliece6960119pc-keypair
+ mceliece8192128-dec
+ mceliece8192128-enc
+ mceliece8192128f-keypair
+ mceliece8192128-keypair
+ mceliece8192128pc-dec
+ mceliece8192128pc-enc
+ mceliece8192128pcf-keypair
+ mceliece8192128pc-keypair
+ mceliece-fulltest
+ mceliece-speed
+ mceliece-test
  .
- Internally, libmceliece is based on the official Classic McEliece software,
- specifically the vec implementation (designed to work portably across CPUs) and
- he avx implementation (designed for higher performance on Intel/AMD CPUs with
- AVX2 instructions). libmceliece includes automatic run-time selection
- of implementations.
+ Each tool exits 0 on success, nonzero on failure.
  .
- libmceliece is intended to be called by larger multi-function libraries
- (such as traditional cryptographic libraries), including libraries in other
- languages via FFI. The idea is that libmceliece takes responsibility for
- the details of Classic McEliece computation, including optimization,
- timing-attack protection, and (in ongoing work) verification,
- freeing up the calling libraries to concentrate on application-specific
- needs such as protocol integration. Applications can also call libmceliece
- directly.
+ These tools allow libmceliece to be easily used from shell
+ scripts. Other languages can also use libmceliece via these tools,
+ but languages typically have good support for FFI and can use the C
+ interface directly.
+ .
+ The mceliece-speed, mceliece-test and mceliece-fulltest tools can be used
+ for benchmarking and internal self testing.  Python and Valgrind is only
+ needed for the mceliece-fulltest tool, the other tools are written in C.
  .
  Command line tools.

=== debian/tests/control ===
Test-Command: mceliece-speed
Features:
 test-name=mceliece-speed,
Depends:
 mceliece,

Test-Command: mceliece-fulltest
Architecture: amd64
Features:
 test-name=mceliece-fulltest,
Depends:
 mceliece,
 python3,
 @recommends@,

Tests:
 testmceliece-static,
Depends:
 dpkg-dev,
 build-essential,
 libmceliece-dev,
 librandombytes-dev,

Tests:
 testmceliece-shared,
Depends:
 dpkg-dev,
 build-essential,
 libmceliece-dev,
 libmceliece1,
 librandombytes-dev,

Tests:
 testvalgrind,
Restrictions:
 needs-root,
 skippable,
Depends:
 build-essential,
 libmceliece-dev,
 libmceliece1,
 librandombytes-dev,
 valgrind-if-available,

Tests:
 mceliece,
Depends:
 mceliece,
 xxd,

Test-Command: mceliece-test kem 6960119f
Features:
 test-name=mceliece-test_kem_6960119f,
Depends:
 mceliece,

Test-Command: mceliece-test kem 6688128f
Features:
 test-name=mceliece-test_kem_6688128f,
Depends:
 mceliece,

Test-Command: mceliece-test kem 8192128f
Features:
 test-name=mceliece-test_kem_8192128f,
Depends:
 mceliece,

Test-Command: mceliece-test kem 460896f
Features:
 test-name=mceliece-test_kem_460896f,
Depends:
 mceliece,

Test-Command: mceliece-test kem 348864f
Features:
 test-name=mceliece-test_kem_348864f,
Depends:
 mceliece,

## libmceliece 0~20250507

=== debian/changelog ===
libmceliece (0~20250507-4) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/watch: rewrite to version 5
  * d/salsa-ci.yml: add SALSA_CI_AUTOPKGTEST_ALLOWED_EXIT_STATUS: '0'
  * d/control: remove Rules-Requires-Root: no

  [ Simon Josefsson ]
  * Re-generate man-pages.
  * Add lrc.excludes.
  * Tighten Salsa CI.
  * Add lintian overrides.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 02 Nov 2025 21:29:11 +0100

libmceliece (0~20250507-3) unstable; urgency=medium

  * d/control: change maintainer to pkg-security

 -- Jan Mojžíš <janmojzis@debian.org>  Tue, 19 Aug 2025 07:04:39 +0200

libmceliece (0~20250507-2) unstable; urgency=medium

  * Upload to unstable.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 16 Aug 2025 12:49:27 +0200

libmceliece (0~20250507-1) experimental; urgency=medium

  * New upstream version 0~20250507
  * Standards-Version: 4.7.2.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 08 May 2025 02:16:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libmceliece
-Maintainer: Jan Mojžíš <janmojzis@debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
+ Jan Mojžíš <janmojzis@debian.org>,
  Simon Josefsson <simon@josefsson.org>,
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://lib.mceliece.org
 Build-Depends:
@@ -11,11 +12,11 @@
  dh-python,
  libcpucycles-dev,
  librandombytes-dev,
+ pandoc [!m68k !sh4 !x32] <!nodoc>,
  python3,
  valgrind-if-available,
 Vcs-Git: https://salsa.debian.org/debian/libmceliece.git
 Vcs-Browser: https://salsa.debian.org/debian/libmceliece
-Rules-Requires-Root: no
 
 Package: libmceliece-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,24 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack
 
+# disable hardening-stackclash on armhf
+# On armhf, valgrind test dies with a SIGSEGV when
+# built with either -fstack-clash-protection or -fstack-check.
+# And also on ppc64el.
+ifeq ($(DEB_TARGET_ARCH), armhf)
+export DEB_BUILD_MAINT_OPTIONS = hardening=hardening=+all,-stackclash
+endif
+ifeq ($(DEB_TARGET_ARCH), ppc64el)
+export DEB_BUILD_MAINT_OPTIONS = hardening=hardening=+all,-stackclash
+endif
+
 # crossbuild
 ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
 include /usr/share/dpkg/buildtools.mk
 endif
 
 %:
-	dh $@
+	dh $@ --with python3
 
 # The debian/compiler directory contains gcc and clang wrappers.
 # It adds Debian specifific options distributed in
@@ -25,9 +36,19 @@
 ABINAME=amd64
 endif
 
+COMMAND_VALGRIND = $(shell command -v valgrind)
+
+ifeq ($(filter /usr/bin/valgrind,$(COMMAND_VALGRIND)),)
+DISABLE_VALGRIND += --no-valgrind
+endif
+
 override_dh_auto_configure:
-	# run configure
-	./configure --host=$(ABINAME) --prefix=/usr
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	head -v $(shell find . -name mceliece.1)
+	(! command -v pandoc) || autogen/man
+	head -v $(shell find . -name mceliece.1)
+endif
+	./configure --host=$(ABINAME) --prefix=/usr $(DISABLE_VALGRIND)
 
 override_dh_auto_clean:
 	rm -rf ./build

=== debian/watch ===
Version: 5
Source: https://lib.mceliece.org/download.html
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
Uversion-Mangle: s/^/0~/
